"""
GNU GPLv3-or-later
Lorenzo Mari - 2022

This file is part of Tor Space.

Tor Space is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software Foundation,
either version 3 of the License, or (at your option) any later version.

Tor Space is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with Tor Space.
If not, see <https://www.gnu.org/licenses/>. 
"""

from os import system
from time import sleep
from sys import argv

import client

from multiprocessing import Process
import node


STOP_SIGNAL = "!!STOPCONNECTION!!"


print("starting listening node")
server = Process(target=node.run)
server.start()

client.refresh_proxy()

if "--port" in argv:
	if argv.index("--port")+1 < len(argv):
		port = argv[argv.index("--port")+1]
		client.refresh_proxy(tor_port=port)


print("\n\npaste peer address (###.onion):\n\n")
PEER = "http://"+input()#sg.popup_get_text("peer address (###.onion):")
username = input("user: ")#sg.popup_get_text("username:")

public_key = client.get_key(PEER)


print("\nConversation initialized. Press CTRL+C to quit\n\n", '='*24)
try:
	while 1:
		client.send_message(username, input(":"), PEER, public_key)
		
except KeyboardInterrupt:
	print('\n'+'='*24+"\nquitting")
	client.send_message(username, STOP_SIGNAL, PEER, public_key)
	server.terminate()
	server.join()


print("goodbye")
